#!/usr/bin/env python3

from typing import Union

import wx

from Items import Item


class Channel:
    def __init__(self,
                 provider_name: str,
                 feed: str,
                 logo: wx.Bitmap,
                 name: str) -> None:
        self.m_logo = logo
        self.m_provider_name = provider_name
        self.m_name = name
        self.m_feed = feed
        self.m_items: Union[list[Item], None] = None
        self.m_screen_width = 720/2

    def get_logo_as_bitmap(self) -> wx.Bitmap:
        return self.m_logo

    def get_feed(self) -> str:
        return self.m_feed

    def get_items(self) -> Union[list[Item], None]:
        return self.m_items

    def get_name(self) -> str:
        return self.m_name

    def get_provider_name(self) -> str:
        return self.m_provider_name

    def parse_feed(self) -> Union[list[Item], None]:
        pass

    def wait(self) -> bool:
        return False

    def get_latest_item(self) -> Item:
        return self.m_items[0] # type: ignore

    def set_items(self, items: list[Item]) -> None:
        self.m_items = items

    def set_logo(self, logo: wx.Bitmap) -> None:
        self.m_logo = logo
